n, m = map(int, input().split())
r = float(input())

production_days = {}
max_inspection_day = 0

for _ in range(n):
    day, raw_material = map(int, input().split())
    production_days[day] = raw_material
    max_inspection_day = max(max_inspection_day, day)

inspection_days = list(map(int, input().split()))

waste = 0
result = []

for day in range(1, max(max_inspection_day, max(inspection_days)) + 1):
    if day in production_days:
        waste = (1 - r) * waste + r * production_days[day]
    else:
        waste *= (1 - r)
        
    if day in inspection_days:
        formatted_val = round(waste, 6)
        if int((formatted_val * 1000000) % 1000000) > 900000:
            formatted_val = int(formatted_val) + 1
        elif formatted_val - int(formatted_val) == 0:
            formatted_val = int(formatted_val)
        result.append(formatted_val)

print(' '.join(map(str, result)), end='')
