#include "bits/stdc++.h"
using namespace std;

#ifdef ORD_SET
    #include <ext/pb_ds/assoc_container.hpp>
    #include <ext/pb_ds/tree_policy.hpp>
    using namespace __gnu_pbds;
    template<typename T>
    using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#endif
#ifdef ROPE
    #include <ext/rope>
    using namespace __gnu_cxx;
#endif

// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")

using ll = long long;
using ld = long double;
#define pll pair<ll, ll>
#define pb push_back
#define ff first
#define ss second
#define sp " "
#define en "\n"
#define bg begin()
#define ed end()
// #define sz size()
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void freopen(string s) { freopen((s+".in").c_str(), "r", stdin); freopen((s+".out").c_str(), "w", stdout); }
void EvrazGold() { ios_base::sync_with_stdio(false); cin.tie(NULL); }
ll binmul(ll a, ll b, ll c) { ll res = 0; while(b) { if(b&1) (res += a) %= c; (a += a) %= c; b >>= 1; } return res; }
ll binpow(ll a, ll b, ll c) { ll res = 1; while(b) { if(b&1) (res *= a) %= c; (a *= a) %= c; b >>= 1; } return res; }
template<typename T> T gcd(T a, T b) { if(b==0) return a; return gcd(b, a%b); }
template<typename T> T lcm(T a, T b) { return a/gcd(a, b)*b; }
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ld rnd() { return rng()%INT_MAX*1.0/INT_MAX; }
const ll inf = 1e18+7, MX = LLONG_MAX, MN = LLONG_MIN;
const ll mod = 1e9+7, N = 3e5+5;
ll a[N], b[N], t[N*4], dp[N], d[N];

void update(ll v, ll tl, ll tr, ll pos, ll x) {
    if(tl==tr) {
        t[v] = x;
        return;
    }
    ll tm = (tl+tr)/2;
    if(pos<=tm) update(v*2, tl, tm, pos, x);
    else update(v*2+1, tm+1, tr, pos, x);
    t[v] = min(t[v*2], t[v*2+1]);
}

ll get(ll v, ll tl, ll tr, ll l, ll r) {
    if(r<tl || tr<l) return inf;
    if(l<=tl && tr<=r) return t[v];
    ll tm = (tl+tr)/2;
    return min(get(v*2, tl, tm, l, r), get(v*2+1, tm+1, tr, l, r));
}

void psycho() {
    ll n;
    cin>>n;
    for(ll i=1; i<=n; i++) cin>>a[i];
    for(ll i=1; i<=n; i++) cin>>b[i];
    stack<ll> st;
    for(ll i=1; i<=n; i++) {
        ll x = i;
        while(!st.empty() && a[i]>a[st.top()]) st.pop();
        if(!st.empty()) x = st.top();
        st.push(i);
        d[i] = dp[i-1]+b[i];
        d[i] = min(d[x], d[i]);
        dp[i] = d[i];
        if(x<i) dp[i] = min(dp[i], get(1, 1, n, x, i-1)+b[i]);
        else dp[i] = min(dp[i], b[i]);
        update(1, 1, n, i, dp[i]);
        // cout<<dp[i]<<" "<<x<<"\n";
    }
    cout<<dp[n]<<" ";
    return;
}

signed main(/*Nurmyrza, Beibarys, Amir*/) {
    // freopen("");
    EvrazGold();
    ll tt = 1;
    // cin>>tt;
    for(ll i=1; i<=tt; i++) {
        psycho();
    }
}
