#include "bits/stdc++.h"
using namespace std;

#ifdef ORD_SET
    #include <ext/pb_ds/assoc_container.hpp>
    #include <ext/pb_ds/tree_policy.hpp>
    using namespace __gnu_pbds;
    template<typename T>
    using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#endif
#ifdef ROPE
    #include <ext/rope>
    using namespace __gnu_cxx;
#endif

// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")

using ll = long long;
using ld = long double;
#define pll pair<ll, ll>
#define pb push_back
#define ff first
#define ss second
#define sp " "
#define en "\n"
#define bg begin()
#define ed end()
// #define sz size()
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void freopen(string s) { freopen((s+".in").c_str(), "r", stdin); freopen((s+".out").c_str(), "w", stdout); }
void EvrazGold() { ios_base::sync_with_stdio(false); cin.tie(NULL); }
ll binmul(ll a, ll b, ll c) { ll res = 0; while(b) { if(b&1) (res += a) %= c; (a += a) %= c; b >>= 1; } return res; }
ld binpow(ld a, ll b, ll c) { ld res = 1; while(b) { if(b&1) (res *= a); (a *= a); b >>= 1; } return res; }
template<typename T> T gcd(T a, T b) { if(b==0) return a; return gcd(b, a%b); }
template<typename T> T lcm(T a, T b) { return a/gcd(a, b)*b; }
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ld rnd() { return rng()%INT_MAX*1.0/INT_MAX; }
const ll inf = 1e18+7, MX = LLONG_MAX, MN = LLONG_MIN;
const ll mod = 1e9+7, N = 3e5+5;

ll n, m;
ld d[N], w[N];
pair<ld, ld> a[N];
ld r, dp[N];

void psycho() {
    cout<<fixed<<setprecision(6);
    cin>>n>>m>>r;
    ld y = (1 - r);
    for(int i = 1; i <= n; i ++) {
        cin>>a[i].ff>>a[i].ss;
    }
    sort(a + 1, a + n + 1);
    for(int i = 0; i <= n; i++) {
        d[i] = a[i].ff;
        w[i] = a[i].ss;
        // cout<<d[i]<<" "<<w[i]<<endl;
    }
    for(int i = 1; i <= n; i ++) {
        dp[i] = (dp[i - 1] * binpow(y, d[i] - d[i - 1], 1) + r * w[i]);
    }
    while(m --) {
        ll q; cin>>q;
        ll p = (lower_bound(d, d + n + 1, q + 1) - d - 1);
        // cout<<p<<endl;
        cout<<dp[p] * binpow(y, q - d[p], 1)<<" ";
    }
    return;
}

signed main(/*Nurmyrza, Beibarys, Amir*/) {
    // freopen("");
    EvrazGold();
    ll tt = 1;
    // cin>>tt;
    for(ll i=1; i<=tt; i++) {
        psycho();
    }
}
