#include <bits/stdc++.h>

using namespace std;

//#pragma GCC target( "sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
//#pragma GCC optimize("Ofast,unroll-loops,fast-math,O3")

#define ff first
#define ss second
#define vt vector
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()
#define ent "\n"
#define sp ' '

using ll  = long long;
using db  = double;
using ldb = long double;
using pll = pair <ll, ll>;
using pii = pair <int, int>;

const ll  INF = 8e18;
const ll  inf = 1e9 + 7;
const int MOD = 998244353;
const int bln = 200;
const int M   = 2e3 + 7;
const int N   = 1e2 + 7;

/*-------------------------main-------------------------*/

char a[N][N];
bool used[N][N];

int dfs(int i, int j){
    used[i][j] = 1;
    int sum = 1;
    if (i > 1 && a[i - 1][j] == '#' &&  !used[i - 1][j]) {
        sum += dfs(i - 1, j);
    }
    if (j > 1 && a[i][j - 1] == '#' && !used[i][j - 1]){
        sum += dfs(i, j - 1);
    }
    if (i < 10 && a[i + 1][j] == '#' && !used[i + 1][j]){
        sum += dfs(i + 1, j);
    }
    if (j < 10 && a[i][j + 1] == '#' && !used[i][j + 1]){
        sum += dfs(i, j + 1);
    }
    return sum;
}

bool check(int i, int j){
    if (i > 1 && j > 1 && a[i - 1][j - 1] == '#') return 1;
    if (i < 10 && j < 10 && a[i + 1][j + 1] == '#') return 1;
    if (i < 10 && j > 1 && a[i + 1][j - 1] == '#') return 1;
    if (i > 1 && j < 10 && a[i - 1][j + 1] == '#') return 1;
    if (i > 1 && j > 1 && a[i - 1][j] == '#' && a[i][j - 1] == '#') return 1;
    if (i > 1 && j < 10 && a[i - 1][j] == '#' && a[i][j + 1] == '#') return 1;
    if (i < 10 && j > 1 && a[i + 1][j] == '#' && a[i][j - 1] == '#') return 1;
    if (i < 10 && j < 10 && a[i + 1][j] == '#' && a[i][j + 1] == '#') return 1;
    return 0;
}

void solve() {
    #define test
    for (int i = 1; i <= 10; i++){
        for (int j = 1; j <= 10; j++){
            cin >> a[i][j];
        }
    }
    for (int i = 1; i <= 10; i++){
        for (int j = 1; j <= 10; j++){
            if (a[i][j] == '#' && check(i, j)){
                cout << "NO" << ent;
                return;
            }
        }
    }
    int odin = 0, dva = 0, tri = 0, che = 0;
    for (int i = 1; i <= 10; i++){
        for (int j = 1; j <= 10; j++){
            if (a[i][j] == '#' && !used[i][j]){
                int x = dfs(i, j);
                if (x == 4) che++;
                else if (x == 3) tri++;
                else if (x == 2) dva++;
                else odin++;
            }
        }
    }
    if (che == 1 && tri == 2 && dva == 3 && odin == 4) cout << "YES";
    else cout << "NO";
}

void precalc() {
}

signed main() {
//  freopen("lca.in", "r", stdin);
//  freopen("lca.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    precalc();
    int testcases;
    #ifdef tests
        cin >> testcases;
    #endif
    #ifdef test
        testcases = 1;
    #endif
    while (testcases--) {
        solve();
    }
    return 0;
}
