def inspect_waste(n, r, production_data):
    waste = [0] * (n + 1)
    for i in range(1, n + 1):
        w_i = production_data[i - 1][1]  # количество использованного сырья в текущий день
        waste[i] = (1 - r) * waste[i - 1] + r * w_i
    return waste

# Пример использования
n = 5  # количество дней
r = 0.5  # коэффициент переработки сырья
production_data = [(1, 10), (2, 5), (3, 15), (4, 0), (5, 7)]  # данные о производстве в формате (день, количество использованного сырья)
result = inspect_waste(n, r, production_data)
print(result[1:])  # вывод отходов в конце каждого дня, начиная с первого дня
