#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

char c[12][12];
vector<pair<int,int>> a;
bool used[12][12];

void rec(int x, int y) {
    a.push_back(make_pair(x, y));
    used[x][y] = 1;
    if (c[x - 1][y] == '#' && !used[x - 1][y])
        rec(x - 1, y);
    if (c[x + 1][y] == '#' && !used[x + 1][y])
        rec(x + 1, y);
    if (c[x][y - 1] == '#' && !used[x][y - 1])
        rec(x, y - 1);
    if (c[x][y + 1] == '#' && !used[x][y + 1])
        rec(x, y + 1);
    if (c[x - 1][y - 1] == '#' && !used[x - 1][y - 1])
        rec(x - 1, y - 1);
    if (c[x + 1][y + 1] == '#' && !used[x + 1][y + 1])
        rec(x + 1, y + 1);
    if (c[x + 1][y - 1] == '#' && !used[x + 1][y - 1])
        rec(x + 1, y - 1);
    if (c[x - 1][y + 1] == '#' && !used[x - 1][y + 1])
        rec(x - 1, y + 1);
}

int main() {
    for (int i = 1; i <= 10; i++)
        for (int j = 1; j <= 10; j++)
            cin >> c[i][j];
    int C[5];
    C[1] = 0;
    C[2] = 0;
    C[3] = 0;
    C[4] = 0;
    for (int i = 1; i <= 10; i++)
        for (int j = 1; j <= 10; j++)
            if (c[i][j] == '#' && used[i][j] == 0) {
                a.clear();
                rec(i, j);
                int mnx = a[0].first, mxx = a[0].first;
                int mny = a[0].second, mxy = a[0].second;
                for (int k = 1; k < a.size(); k++) {
                    mnx = min(mnx, a[k].first);
                    mxx = max(mxx, a[k].first);
                    mny = min(mny, a[k].second);
                    mxy = max(mxy, a[k].second);
                }
                if (mnx != mxx && mny != mxy) {
                    cout << "NO";
                    return 0;
                }
                C[a.size()]++;
            }
    if (C[1] != 4 || C[2] != 3 || C[3] != 2 || C[4] != 1)
        cout << "NO";
    else 
        cout << "YES";
    return 0;
}

