n, m = map(int, input().split())
costs = list(map(int, input().split()))

# Шаг 1: Найдите общую стоимость проживания
total_cost = sum(costs)

# Шаг 2: Найдите среднюю стоимость проживания в день
average_cost_per_day = total_cost / n

# Шаг 3: Найдите все делители средней стоимости
possible_costs = set()
for i in range(1, int(average_cost_per_day**0.5) + 1):
    if average_cost_per_day % i == 0:
        possible_costs.add(i)
        possible_costs.add(int(average_cost_per_day / i))

# Преобразуйте множество в список и отсортируйте его
possible_costs = list(possible_costs)
possible_costs.sort()

# Выведите результат
print(len(possible_costs))
print(*possible_costs)
