//coded by seeyou
/* @@@@@@@@@@@@@@@@@@@@@@*+++*====*+:::++*===**++:::::::::::::+*@@@@@#####@@@@@@
 @@@@@@@@@@@@@@@@@@@@#+**++*+::::::+==+:::::::::::+****++::::+++#@######@@@@@@@@
 @@@@@@@@@@@@@@@@##@***+++::::+++**+::::::::::+=*++::+++++++:::+:=@=**#@@@@@@@@@
 @@@@@@@@@@@@@@@##=+:--------------------+==#======*+:::::::++::+:=+++:+@@@@@@@@
 @@@@@@@@@@@@@#::+*===*****----:::::::++::::*:+++**=====*+:::::+:+:==*+::*@@@@@@
 @@@@@@@@@@@@#+++==:-.--:+*---:::::+++*=::::*::::::::::+*===+::::+++==*+::+@@@@@
 @@@@@@@@@@#..-.+=:.--:::++---::::+++++++++:*===*++:::::::::+=*:::++===++::+@@@@
 @@@@@@@@@#*--:-++::*====++:::+:++++++++++++*+::++++++++::::::::+::+*#==++:+@#@@
 @@@@@@@@@@:::::*=+=######=*::+=#=++:::+++++**+:::::::::::+++:::::+++#==*+:+@#@@
 @@@@@@@@@@*##=+*##########*::+++++**=*=++++======*+:::::::::::++:::*#===+++@##@
 @@@@@@@@@@@####*###@#####+:::++++++*+****=::++*=========*+++++**++++#===*++@###
 @@@@@@@@@@@@##+=########=+:::++***==#=**++*==*++::+*====+++*====*===@===*:+@##@
 @@@@@@@@@@@#***=#########=====**+++++++++++*==++==*+:::+*==*:::::+*=#====::@##@
 @@@@@@@@@@@@@######=**+++++++=####*++*####+=*+**+:+====*+:::+**+::::#====::##@@
 @@@@@@@@@@@@@@==*++++++=##***#####**+######=#**=====**======*+:::::=====*+:#@@@
 @@@@@@@@@@@@@@@@#=++++##@@@@W##@#****=###*:*=++======#===#=========#====*::=@@@
 @@@@@@@@@@@@@@#=@W#++++#@W@==@WWWW@@@@@@=**=#=**===*+++**+*=======@====*+::=@@@
 @@@@@@@@@@@@@#=**#@*+++***=#*+=#@@@@#==**==:+**+*#+++*===++======#@==*=++::=@@@
 @@@@@@@@@@@@@@=++*+++++*+=**+::++++*#=++++*==*+**+++++**+++======@@==*=:++:=#@@
 @@@@@@@@@@@@@@=*++++++++*=##++++++++=####++===++++++=====++=====@@#==**+:=:=##@
 @@@@@@@@@@@@@@*++++++++*####=++##+++#####++==**+++++*==*++*===#@@@#==*++*#:##@@
 @@@@@@@@@@@@@#++++++++++=###*++++++++***+++:+**+++****+++*====#@@@#=**::@#+##@@
 @@@@@@@@@@@@@@@*#*++++++++++++++++++++++++*#=***++++:++=#=====@@@@@=*+:=@#*@@@@
 @@@@@@@@@@@@@@@#+=*++++++++++++++++++++++++**=+++++*=###====#@@@@@@=++=@@==@@@@
 @@@@@@@@@@@@@@:*=**++++++++++++++++++++++++##==@#=##====##==@#@@@@@#+#@@@=@@@@@
 @@@@@@@@@@@@@@@*=*+#@===*****=*++++++++++++:**=#==+++++*=###@@@@@###*#@@@#@@@@@
 @@@@@@@@@@@@@@#*=@++++++***+++++++++++++++*#####*+++++++++=#@W@W@@@@==@@@@@@@@@
 @@@@@@@@@@@@@@++**@*+====*+++++++++++++++=###=*++*=##=*+++++++++#@@@@*@@@@@@@@@
 @@@@@@@@@@@@@@#+=@@@+++++++++++++++++*==#:+*==*+++++++++++++++++=@@@@@#@@@@@@@@
 @@@@@@@@@@@@@@@#=@@@=++++++++++++==#####==#=**+++++++++*=##@@@@@@W@@@@@@@@@@@@@
 @@@@@@@@@@@@@@=***@@@@=****=#@W@###===##**==+++*=#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 @@@@@@@@@@@@@@@##@@@@@@@@@@@@######==#*+*#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 W@@@@@@@@@@@@@@#=@@@@@@@@W#########@W@####@@@@@@@@@@@@@@@@@@@@@@@WW@@@@@@@@@@@@
 WW@@@@@@@@@@@@====@@@@@@@@###@WWWWW@@==@@@@@@@@@@@@@@@@@@@@@@@WWWWW@@@W@@@@@@@@
 WWWW@@@@@@@@@@@#@@@@@@@@@@WWWWWWW@**=@@@@@@@@@@@@@@@@@@@@WWWWWWWWW@@W@@@@@@@@@@
 WWWWWWWW@@@@@@@==@@@@WW@@@@@WWWW#=#@@WWWWWWWWWWWWWWWWWWWWWWW@@@@@@@@WW@@@W@@@@W
 WWWWWWWW@@@@@@@###@WW@@@@@@@@@@@@@@@@@@@@WWWWWWWWWWWWWWWWWWWWWWWWWWWW@@@@WW@@@@
 WWWWWWWWW@@@@@@##@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@W@@@
 WWWWWWWWW@WWW@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 WWWW@#=====****************=##@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 */
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <numeric>
#include <queue>
#include <set>

using namespace std;

#define all(x) x.begin(), x.end()
#define ll long long
#define en endl;


void solve () {
    ll k;
    cin >> k;
    string mirror;
    bool zero = true;
    while (k > 0) {
        ll d = k % 10;
        if (d == 2)
            mirror += "5";
        else if (d == 5)
            mirror += "2";
        else {
            mirror += to_string(d);
        }
        if (zero && mirror[mirror.size() - 1] == '0') {
            mirror.pop_back();
        } else {
            zero = false;
        }
        k /= 10;
    }
    if (mirror.empty()) {
        mirror = "0";
    }
    cout << mirror << endl;
}
int main () {
        solve();
    }
