#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <bitset>

using ll = long long;
template<typename T>
bool rMin(T& a, const T& b){
    if(b < a){
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool rMax(T& a, const T& b){
    if(a < b){
        a = b;
        return true;
    }
    return false;
}

using namespace std;

void solve(){
    int a, b;
    __int64 ans = 0;
    cin >> a >> b;
    while(a > 1 && b > 1){
        ans += (ll) a * b;
        if(a > b){
            ans += ((ll) b * (b + 1)) / 2 + b - 1;
            --a;
        }
        else{
            ans += ((ll) a * (a + 1)) / 2 + a - 1;
            --b;
        }
    }
    if(a == 1)
        ans += ((ll) b * (b + 1)) / 2 + b - 1;
    else
        ans += ((ll) a * (a + 1)) / 2 + a - 1;

    cout << ans << '\n';

}

int main(){
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    int t = 1;

    //cin >> t;

    for(int i = 0; i < t; ++i){
        solve();
    }
}