# Считываем входные данные
n, m = map(int, input().split())
costs = list(map(int, input().split()))

# Создаем словарь для хранения информации о стоимостях услуг за каждый день
service_costs = {}
for i in range(m):
    service_costs[costs[i]] = service_costs.get(costs[i], 0) + 1

# Перебираем все возможные варианты стоимости проживания Сергея
possible_costs = []
for i in range(n):
    total_cost = int(input())
    possible = True
    for cost, count in service_costs.items():
        if (total_cost - cost) not in service_costs or (total_cost - cost == cost and count < 2):
            possible = False
            break
    if possible:
        possible_costs.append(total_cost)

# Выводим результат
print(len(possible_costs))
print(*possible_costs)
