#include <bits/stdc++.h>

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

#define fi first
#define se second
#define pb push_back
#define fr(i, l, r) for (int i = (l); i <= (r); ++i)
#define rf(i, l, r) for (int i = (l); i >= (r); --i)

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 2 * 1e5 + 5;

vector <int> cnt[N];
set <int> start[N];
int t[N], cur[N];

void rec(int v, int d) {
    if (d == 0) return;
    cur[v] = d;
    rec(v << 1, d - 1);
    rec(v << 1 | 1, d - 1);
}

int flag[N * 4];
int need, n;
void dfs(int v, int color) {
    // cout << v << " - " << need << "\n";
    if (need == 0) {
        return;
    }
    if (flag[v] == 1) {
        cout << "-1\n";
        exit(0);
    }
    flag[v] = color;
    start[need].erase(v);
    need--;
    if (v * 2 <= n && flag[v * 2] == 0) dfs(v * 2, color);
    else if (v * 2 + 1 <= n && flag[v * 2 + 1] == 0) dfs(v * 2 + 1, color);
}

int tt[N * 4], arr[N], m = 0;
void build2(int v, int tl, int tr) {
    if (tl == tr) {
        tt[v] = arr[tl];
        return;
    }
    int tm = (tl + tr) >> 1;
    build2(v << 1, tl, tm);
    build2(v << 1 | 1, tm + 1, tr);
    tt[v] = min(tt[v << 1], tt[v << 1 | 1]);
}
void solve() {
    cin >> n;
    set <int> st;
    map <int, int> mp;
    vector <int> v1, v2;
    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;
        v1.push_back(x);
        st.insert(x);
        mp[x]++;
    }
    int x = 1, n_ = n, d = 0;
    while (n_ > 0) {
        n_ -= x;
        x *= 2;
        d++;
    }
    for (auto i : st) {
        if (mp[i] > d) {
            cout << "-1\n";
            return;
        }
        cnt[mp[i]].push_back(i);
    }
    rec(1, d);
    for (int i = 1; i <= n; i++) {
        start[cur[i]].insert(i);
    }

    for (int i = d; i >= 1; i--) {

        for (auto ver: cnt[i]) {

            if (sz(start[i]) == 0) {
                cout << "-1\n";
                return;
            }
            int start_v = *start[i].begin();
            start[i].erase(start[i].begin());
            need = i;
            dfs(start_v, ver);
        }
    }
    for (int i = n; i >= n - d; i--) {
        arr[++m] = flag[i];
    }
    build2(1, 1, m);
    for (int i = 1; i <= n; i++) {
        v2.push_back(tt[i]);
    }
    sort(all(v1));
    sort(all(v2));
    if (v1 != v2) {
        cout << "-1\n";
        return;
    }
    for (int i = n; i >= n - d; i--) {
        cout << flag[i] << " ";
    }
}

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
