#include <bits/stdc++.h>

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

#define fi first
#define se second
#define pb push_back
#define fr(i, l, r) for (int i = (l); i <= (r); ++i)
#define rf(i, l, r) for (int i = (l); i >= (r); --i)

using namespace std;

typedef long long ll;
typedef long double ld;

ld bpow(ld a, ll b)
{
    ld ans = 1;
    while(b)
    {
        if(b & 1)
            ans *= a;

        a *= a;
        b >>= 1;
    }

    return ans;
}

void solve() {
    int n, m;
    ld r;

    cout << fixed << setprecision(8);
    cin >> n >> m >> r;

    vector<pair<int, int>> ls(n);
    vector<pair<int, int>> q(m);
    fr (i, 0, n - 1)
        cin >> ls[i].fi >> ls[i].se;

    fr (i, 0, m - 1)
        cin >> q[i].fi, q[i].se = i;
    vector<ld> ans(m);

    ls.pb({0, 0});
    sort(all(ls));
    sort(all(q), [&](pair<int, int> a, pair<int, int> b){ return a.fi > b.fi; });

    ld x = 0;
    fr (i, 0, n)
    {
        if(q.empty())
            break;

        x += ls[i].se * r;

        while(!q.empty() && q.back().fi == ls[i].fi)
        {
            ans[q.back().se] = x;
            q.pop_back();
        }

        if(i != n)
        {
            while(!q.empty() && q.back().fi < ls[i + 1].fi)
            {
                ans[q.back().se] = bpow(1. - r, q.back().fi - ls[i].fi) * x;
                q.pop_back();
            }
        }

        if(i < n)
            x *= bpow(1. - r, ls[i + 1].fi - ls[i].fi);

    }

    int Size = sz(q) - 1;
    fr (i, 0, Size)
    {
        x *= bpow(1. - r, q.back().fi - ls[n].fi);
        ans[q.back().se] = x;
        q.pop_back();
    }

    fr (i, 0, m - 1)
        cout << ans[i] << " ";
    cout << endl;
}

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
