n, m1, m2 = map(int, input().split())

graph1 = set()
graph2 = set()

for _ in range(m1):
    a, b = map(int, input().split())
    graph1.add((a, b))
    graph1.add((b, a))

for _ in range(m2):
    a, b = map(int, input().split())
    graph2.add((a, b))
    graph2.add((b, a))

operations = []

for a in range(1, n + 1):
    for b in range(1, n + 1):
        for c in range(1, n + 1):
            if a != b and b != c and a != c:
                remove_ab = (a, b) not in graph1 and (a, b) in graph2
                remove_bc = (b, c) not in graph1 and (b, c) in graph2
                remove_ac = (a, c) not in graph1 and (a, c) in graph2

                if remove_ab and remove_bc and remove_ac:
                    operations.append((a, b, c))
                    graph1.add((a, b))
                    graph1.add((b, a))
                    graph1.add((b, c))
                    graph1.add((c, b))
                    graph1.add((a, c))
                    graph1.add((c, a))

if graph1 == graph2:
    print("YES")
    print(len(operations))
    for operation in operations:
        print(*operation)
else:
    print("NO")
