﻿#include <iostream>
#include <fstream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <string>
#include <set>
#include <cmath>
#include <limits.h>
#include <map>
#include <sstream>
#include <deque>
#include <queue>
#include <valarray>
#include <array>
#include <unordered_map>

#define rep(i, st, n) for(int (i) = (st); (i) < (n); ++(i))
#define repb(i, st, n) for(bool (i) = (st); (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pb push_back
#define nl "\n"

int const INF = 1e9 + 1000 - 7;

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef string str;
typedef pair < int, int > pii;
typedef pair < ll, ll > pll;
typedef pair < ll, int > pli;
typedef vector <int> vi;
typedef vector < vector<int> > vvi;
typedef vector < pii > vpii;
typedef vector < pair<int, ll> > vpil;
typedef vector < ll > vll;


unordered_map<int, int> cnt;

bool cmp(int a, int b) {
    return cnt[a] > cnt[b];
}


int logg(int a) {
    int res = 0;
    while (a % 2 == 0) {
        res++;
        a /= 2;
    }
    return res;
}

void solve() {
    int n; cin >> n;

    vi a;
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;

        if (!cnt[k]) {
            a.pb(k);
        }
        cnt[k]++;
    }
    sort(all(a), cmp);
    bool is = true;
    int m = (n + 1) / 2;
    vi cn(m);
    int lg = logg(m);
    int cr = lg;
    cn[0] = lg + 1;
    for (int i = 1; i < m; ++i) {
        int j = i;
        for (j = i; j < i + (1 << (lg - cr)); ++j) {
            cn[j] = cr;
        }
        cr--;
        i = j - 1;
    }
    vi ans(m);
    for (int i = 0; i < m; ++i) {
        if (cnt[a[i]] != cn[i]) {
            is = false;
            break;
        }
    }
    if (!is) {
        cout << -1;
        return;
    }
    map<int, vector<int>> mp; // числа для кнт 
    for (int i = 0; i < m; ++i) {
        mp[cnt[a[i]]].pb(a[i]);
    }
    unordered_map<int, vi> pos;

    
    ans[0] = mp[lg + 1][0];
    if(n != 1) ans[m / 2] = mp[lg][0];
    pos[lg + 1].pb(0);
    if (n != 1) pos[lg].pb(m / 2);
    for (int i = lg - 1; i >= 1; --i) {
        for (int j = lg + 2; j > i; --j) {
            for (auto k : pos[j]) {
                int new_pos = k + (1 << (i - 1));
                pos[i].pb(new_pos);
            }
        }
    }
    for (auto i : pos) {
        for (int j = 0; j < i.second.size(); ++j) {
            ans[i.second[j]] = mp[i.first][j];
        }
    }
    
    for (int i = 0; i < m; ++i) cout << ans[i] << ' ';
}

int main()
{
    cin.tie(0); ios::sync_with_stdio(0); cout.tie(0);
    int t = 1;// cin >> t;
    while (t--) {
        solve();
    }
}
