n, m = map(int, input().split())
costs = list(map(int, input().split()))

room_costs = [0]  # Начальное значение для стоимости номера за день

for i in range(n - 1, -1, -1):
    remaining_cost = costs[i]
    room_cost = room_costs[-1]  # Последний известный вариант стоимости номера

    if remaining_cost > room_cost:
        # Не сможем вычесть большую стоимость, это невозможный вариант
        print(0)
        exit()

    if remaining_cost < room_cost:
        # Добавляем новый вариант стоимости номера
        room_costs.append(remaining_cost)

# Выводим количество возможных вариантов стоимости и сами варианты
print(len(room_costs) - 1)  # Вычитаем 1, так как начальное значение не учитываем
print(" ".join(map(str, room_costs[1:])))
