#include <string>
#include <map>
#include <cstring>
#include <bitset>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <iostream>
#include <memory.h>
#include <list>
#include <vector>
#include <set>
#include <stack>
#include <deque>
#include <queue>
#include <complex>
#include <array>
#include <unordered_map>
#include <unordered_set>
#include <numeric> // Include the numeric header for std::gcd()
#define ll long long
#define EL '\n'
using namespace std;
#define LL long long


#define PB push_back
#define MP make_pair
#define AA first
#define BB second
#define SZ size()
#define BG begin()
#define OP begin()
#define ED end()

vector <vector<int>> field(10, vector<int>(10));
vector <vector<int>> used(10, vector<int>(10));
int dx[] = { 0, 0, -1, 1 };
int dy[] = { 1, -1, 0, 0 };

int ax[] = { 1, 1, -1, -1 };
int ay[] = { -1, 1, -1, 1 };

int gcd(int a, int b) {
    if (b == 0)
        return a;
    else
        return gcd(b, a % b);
}


bool comp(pair <string, pair<int, int>> first, pair <string, pair<int, int>> second) {
    return first.first < second.first;
}



int dfs(pair <int,int> node) {
    used[node.first][node.second] = 1;

    int count = 1;

    for (int i = 0; i < 4; i++) {
        int x = node.first + dx[i];
        int y = node.second + dy[i];

        if (x >= 0 and x < 10 and y >= 0 and y < 10) {
            if (used[x][y] == 0 and field[x][y] == 1) {
                count += dfs({ x,y });
            }
        }
    }

    return count;
}


using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    for (int i = 0; i < 10; i++) {
        for (int j = 0; j < 10; j++) {
            char c;
            cin >> c;

            if (c == '.') {
                field[i][j] = 0;
            }
            else {
                field[i][j] = 1;
            }
        }
    }
    for (int i = 0; i < 10; i++) {
        for (int j = 0; j < 10; j++) {
            for (int k = 0; k < 4; k++) {
                int x = i + ax[k];
                int y = j + ay[k];

                if (x >= 0 and x < 10 and y >= 0 and y < 10) {
                    if (field[i][j] == field[x][y] and field[i][j] == 1) {
                        cout << "NO"; 
                        return 0;
                    }
                }
            }
        }
    }



    int comp = 0;
    vector <int> sizes(5);

    for (int i = 0; i < 10; i++) {
        for (int j = 0; j < 10; j++) {
            if (field[i][j] == 1 and used[i][j] == 0) {
                int count = dfs({ i, j });
                
                sizes[count]++;
            }
        }
    }
     
    
    for (int i = 1; i <= 4; i++) {
        if (sizes[i] != 5-i) {
            cout << "NO";
            return 0;
        }
    }

    cout << "YES";
    return 0;
}