#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>

using namespace std;

#define int long long
#define double long double

char a[15][15];
bool used[15][15];

bool check(int istart, int iend, int jstart, int jend) {
    if(istart > 11 || istart < 1 || iend > 11 || iend < 1 || jstart > 11 || jstart < 1 || jend > 11 || jend < 1)
        return 0;
    if(jstart == jend) {
        for(int i = istart; i < iend + 1; i++) {
            if(a[i][jstart - 1] == '#' || a[i][jstart + 1] == '#') {
                return 0;
            }
        }
        if(a[iend + 1][jstart] == '#' || a[iend + 1][jstart - 1] == '#' || a[iend + 1][jstart + 1] == '#' || a[istart - 1][jstart] == '#' || a[istart - 1][jstart - 1] == '#' || a[istart - 1][jstart + 1] == '#') {
            return 0;
        }
    } else if(istart == iend) {
        for(int j = jstart; j < jend + 1; j++) {
            if(a[istart - 1][j] == '#' || a[istart + 1][j] == '#') {
                return 0;
            }
        }
        if(a[iend][jstart - 1] == '#' || a[iend + 1][jstart - 1] == '#' || a[iend - 1][jstart - 1] == '#' || a[istart][jend + 1] == '#' || a[istart + 1][jend + 1] == '#' || a[istart - 1][jend + 1] == '#') {
            return 0;
        }
    } else {
        return 0;
    }
    return 1;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int od = 0, dv = 0, tr = 0, ch = 0;
    for(int i = 1; i < 11; i++) {
        for(int j = 1; j < 11; j++) {
            cin >> a[i][j];
        }
    }
    for(int i = 1; i < 11; i++) {
        for(int j = 1; j < 11; j++) {
            if(a[i][j] == '#') {
                if(a[i + 1][j] == '#' && !used[i + 1][j]) {
                    int temp = 0;
                    while(a[i + temp][j] == '#' && !used[i + temp][j]) {
                        if(used[i + temp][j] == 1) {
                            //cout << i << ' ' << i + temp << ' ' << j << '\n';
                            cout << "NO";
                            return 0;
                        }
                        used[i + temp][j] = 1;
                        temp++;
                    }
                    switch(temp) {
                        case 1:
                            od++;
                            break;
                        case 2:
                            dv++;
                            break;
                        case 3:
                            tr++;
                            break;
                        case 4:
                            ch++;
                            break;
                        default:
                            break;
                    }
                    temp--;
                    if(!check(i, i + temp, j, j)) {
                        //cout << i << ' ' << i + temp << ' ' << j << '\n';
                        cout << "NO";
                        return 0;
                    }
                } else if(a[i][j + 1] == '#' && !used[i][j + 1]) {
                    int temp = 0;
                    while(a[i][j + temp] == '#' && !used[i][j + temp]) {
                        if(used[i][j + temp] == 1) {
                            cout << "NO";
                            return 0;
                        }
                        used[i][j + temp] = 1;
                        temp++;
                    }
                    switch(temp) {
                        case 1:
                            od++;
                            break;
                        case 2:
                            dv++;
                            break;
                        case 3:
                            tr++;
                            break;
                        case 4:
                            ch++;
                            break;
                        default:
                            break;
                    }
                    temp--;
                    if(!check(i, i, j, j + temp)) {
                        //cout << i << ' ' << j + temp << ' ' << j << '\n';
                        cout << "NO";
                        return 0;
                    }
                } else if(!used[i][j]) {
                    od++;
                    if(a[i - 1][j] == '#' || a[i - 1][j - 1] == '#' || a[i - 1][j + 1] == '#' || a[i + 1][j] == '#' || a[i + 1][j - 1] == '#' || a[i + 1][j + 1] == '#') {
                        //cout << i << ' ' << j << '\n';
                        cout << "NO";
                        return 0;
                    } else {
                        used[i][j] = 1;
                    }
                }
            }
        }
    }
    if(ch == 1 && tr == 2 && dv == 3 && od == 4)
        cout << "YES";
    else
        cout << "NO";
    return 0;
}
