#include<iostream>
#include<vector>
#include<string>	
#include<map>
#include<set>
#include<queue>
#include<deque>
#include<iomanip>
#include<cmath>
#include<algorithm>
#include<cstdio>
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;
ll gcd(ll a, ll b) {
	if (b == 0) {
		return a;
	}
	return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}

//=================================



vector<string> a;
vector<vector<bool>> b;
void is(int x, int y, int t) {
	for (int i = x - 1; i <= x + 1; ++i) {
		for (int j = y - 1; j <= y + 1; ++j) {
			if (i < 0 || i > 9 || j < 0 || j > 9) {
				continue;
			}
			else if (i == x && j == y) {
				continue;
			}
			else if (i != x && j != y) {
				if (a[i][j] == '#') {
					cout << "NO";
					exit(0);
				}
			}
			else if (t == 0) {
				if (a[i][j] == '#') {
					cout << "NO";
					exit(0);
				}
			}
			else if (t == 1) {
				if (!(i == x + 1 && j == y) && a[i][j] == '#') {
					cout << "NO";
					exit(0);
				}
			}
			else if (t == 2) {
				if (!(i == x && j == y + 1) && a[i][j] == '#') {
					cout << "NO";
					exit(0);
				}
			}
			else if (t == 3) {
				if (!((i == x + 1 && j == y) || (i == x - 1 && j == y)) && a[i][j] == '#') {
					cout << "NO";
					exit(0);
				}
			}
			else {
				if (!((i == x && j == y + 1) || (i == x && j == y - 1)) && a[i][j] == '#') {
					cout << "NO";
					exit(0);
				}
			}
		}
	}
}

int ship(int x, int y) {
	if (y != 9 && a[x][y + 1] == '#') {
		is(x, y, 2);
		is(x, y + 1, 4);
		b[x][y + 1] = 1;
		y += 2;
		
		int ans = 2;
		while (y < 10) {
			if (a[x][y] != '#') {
				break;
			}
			b[x][y] = 1;
			is(x, y, 4);
			++y;
			++ans;
		}
		return ans;
	}
	else if (x != 9 && a[x + 1][y] == '#') {
		is(x, y, 1);
		is(x + 1, y, 3);
		b[x + 1][y] = 1;
		x += 2;
		int ans = 2;
		while (x < 10) {
			if (a[x][y] != '#') {
				break;
			}
			b[x][y] = 1;
			is(x, y, 3);
			++x;
			++ans;
		}
		return ans;
	}
	else {
		is(x, y, 0);
		return 1;
	}
}

void solve() {
	a.resize(10);
	b.resize(10, vector<bool>(10));
	map<int, int> c;
	for (auto& i : a) cin >> i;
	for (int i = 0; i < 10; ++i) {
		for (int j = 0; j < 10; ++j) {
			if (a[i][j] == '#' && !b[i][j]) {
				b[i][j] = 1;
				c[ship(i, j)]++;
			}
		}
	}
	if (c.size() != 4) {
		cout << "NO";
		return;
	}
	if (c[1] != 4 || c[2] != 3 || c[3] != 2 || c[4] != 1) {
		cout << "NO";
		return;
	}
	cout << "YES";
}

//=================================

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
	return 0;
}