#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<long long, long long>

const int N = 2e+5 + 1;

int n;

int arr[N / 2];

unordered_map < int, set < int > > v;

void Build(int x, int lx, int rx, int prev, int k) {
    if (lx == rx) {
        arr[lx] = prev;
    } else {
        int m = (lx + rx) / 2;

        Build(x + x, lx, m, prev, k - 1);

        int nxt = *v[k - 1].begin();
        v[k - 1].erase(v[k - 1].begin());

        if (nxt < prev) {
            cout << "-1\n";
            exit(0);
        }

        Build(x + x + 1, m + 1, rx, nxt, k - 1);
    }
}

signed main() {
    cin.tie(0); ios_base::sync_with_stdio(0);

    cin >> n;

    unordered_map < int, int > cnt;

    int mn = INT_MAX;

    for (int i = 0, x; i < n; i++)
        cin >> x, cnt[x]++, mn = min(mn, x);    

    for (auto [x, y] : cnt)
        if (x != mn)
            v[y].insert(x);

    Build(1, 0, n / 2, mn, __lg(n + 1));

    for (int i = 0; i <= n / 2; i++)
        cout << arr[i] << " ";
}
