#include <bits/stdc++.h>

#define ll long long
#define pii pair<long long, long long>

using namespace std;

ll n;

vector<ll> t, v, c;

void build(ll x, ll lx, ll rx){
    if(lx==rx){
        t[x]=lx;
        return;
    }
    ll m=(lx+rx)/2;
    build(2*x, lx, m);
    build(2*x+1, m+1, rx);
    if(v[t[2*x]]>=v[t[2*x+1]]) t[x]=t[2*x];
    else t[x]=t[2*x+1];
}

ll get(ll x, ll lx, ll rx, ll l, ll r){
    if(lx>r || rx<l) return 0;
    if(lx>=l and rx<=r) return t[x];
    ll m=(lx+rx)/2;
    ll x1=get(2*x, lx, m, l, r);
    ll x2=get(2*x+1, m+1, rx, l, r);
    if(v[x1]>v[x2]) return x1;
    else return x2;
}

ll d(ll l, ll r){
    if(l==r) return c[l];
    ll m=get(1, 1, n, l, r);
    if(m==l) return c[m];
    if(m==r) return c[m];
    return c[m]+min(d(l, m-1), d(m+1, r));
}

signed main() {
    cin.tie(0); ios_base::sync_with_stdio(0);
    cin>>n;
    t.resize(4*n); v.resize(n+1); c.resize(n+1);
    v[0]=-1;
    for(ll i=1; i<=n; i++) cin>>v[i];
    for(ll i=1; i<=n; i++) cin>>c[i];
    build(1, 1, n);
    cout<<d(1, n)<<"\n";
}