#include <bits/stdc++.h>
#include <queue>
#define speed ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define russian setlocale(LC_ALL, "Russian");
#define ll long long
#define ull unsigned long long
#define bigInt __int128
#define dl double long
#define fl float
#define all(s) s.begin(), s.end()
#define pub push_back
#define pob pop_back
#define ins insert
#define mp make_pair
#define F first
#define S second
#define len length
using namespace std;
bigInt binpow(ull n, ull pw, ull md = 18446744073709551615)
{
    bigInt ret;
    if (pw == 0) return 1;
    if (pw % 2)
    {
        ret = binpow(n, pw - 1, md);
        ret *= n;
    }
    else
    {
        ret = binpow(n, pw / 2, md);
        ret *= ret;
    }
    ret %= md;
    return ret;
}
bigInt GSS(ull p, ull k)
{
    if (p == 1)
    {
        bigInt ret = p * (k + 1ULL);
        return ret;
    }
    bigInt ret = binpow(p, k + 1ULL) - 1ULL;
    ret /= p - 1ULL;
    return ret;
}
bigInt ASS(bigInt a, bigInt b, ull n)
{
    bigInt ret = (a + b) * n;
    ret /= 2;
    return ret;
}
bigInt MMI(bigInt a, ull md)
{
    bigInt ret = binpow(a, md - 2ULL, md);
    return ret;
}
bigInt mdiv(bigInt a, bigInt b, ull md)
{
    bigInt ret = a * MMI(b, md);
    ret %= md;
    return ret;
}
bigInt mmul(bigInt a, bigInt b, ull md = 18446744073709551615)
{
    bigInt ret = (a % md) * (b % md);
    ret %= md;
    return ret;
}
bigInt madd(bigInt a, bigInt b, ull md = 18446744073709551615)
{
    bigInt ret = (a % md) + (b % md);
    ret %= md;
    return ret;
}
ull GCD(ull a, ull b)
{
    ull mx = max(a, b), mn = min(a, b);
    a = mx;
    b = mn;
    if (!(a % b))
        return min(a, b);
    else
    {
        ull r = a % b;
        return GCD(b, r);
    }
}
ull GD(ull a)
{
    for (int i = 2; i <= sqrt(a); ++i)
    {
        if (!(a % i))
        {
            ull ret = a / i;
            return ret;
        }
    }
    return 1;
}
void stTrans(stack<int> &st1, stack<int> &st2)
{
    stack<int> tempSt;
    while (st1.size())
    {
        tempSt.push(st1.top());
        st1.pop();
    }
    while (tempSt.size())
    {
        st2.push(tempSt.top());
        tempSt.pop();
    }
}
void stRev(stack<int> &st)
{
    stack<int> tempSt;
    while (st.size())
    {
        tempSt.push(st.top());
        st.pop();
    }
    stTrans(tempSt, st);
}
void stDisp(stack<int> &st)
{
    stack<int> tempSt;
    while (st.size())
    {
        cout << st.top() << ' ';
        tempSt.push(st.top());
        st.pop();
    }
    while (tempSt.size())
    {
        st.push(tempSt.top());
        tempSt.pop();
    }
}
struct pqComp
{
    bool operator()(const pair<int, int>& p1, const pair<int, int>& p2) const
    {
        return (p1.F < p2.F) || (p1.F == p2.F && p1.S < p2.S);
    }
};
bool pCompF(pair<int, int>& p1, pair<int, int>& p2)
{
    return p1.F < p2.F;
}
bool pCompS(pair<int, int>& p1, pair<int, int>& p2)
{
    return p1.S < p2.S;
}
bool pCompFS(pair<int, int>& p1, pair<int, int>& p2)
{
    return (p1.F < p2.F) || (p1.F == p2.F && p1.S > p2.S);
}
vector <pair<int, int>> ds {{0, 1}, {1, 0}, {0, -1}, {-1, 0}, {-1, -1}, {-1, 1}, {1, -1}, {1, 1}};
int n = 10, was[10];
char a[11][11];
bool vis[11][11];
vector<pair<int,int>> s;

void dfs(int i, int j)
{
    vis[i][j] = 1;
    s.pub({i, j});
    for (auto [dx, dy]: ds)
    {
        if (i + dy >= 1 && i + dy <= n && j + dx >= 1 && j + dx <= n && a[i + dy][j + dx] == '#' && !vis[i + dy][j + dx])
            dfs(i + dy, j + dx);
    }
}

bool check()
{
    if (s.size() > 4)
        return 0;
    bool ok1 = 1, ok2 = 1;
    for (int i = 0; i < s.size() - 1; ++i)
    {
        ok1 = min(ok1, s[i].F == s[i + 1].F);
        ok2 = min(ok2, s[i].S == s[i + 1].S);
    }
    return ok1 || ok2;
}

int main()
{
    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
            cin >> a[i][j];
    }
    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= n; ++j)
        {
            if (a[i][j] == '#' && !vis[i][j])
            {
                dfs(i, j);
                if (!check())
                {
                    cout << "NO\n";
                    return 0;
                }
                was[s.size()]++;
                s.clear();
            }
        }
    }
    if (was[4] == 1 && was[3] == 2 && was[2] == 3 && was[1] == 4)
        cout << "YES\n";
    else
        cout << "NO\n";
}
/*
НЕ ЗАХОДИТ РЕШЕНИЕ?
1) ПРОВЕРЬ НА ОЧЕВИДНЫЕ ОШИБКИ В КОДЕ
2) ПРОВЕРЬ НА ПЕРЕПОЛНЕНИЯ
3) УБЕДИСЬ В ПРАВИЛЬНОСТИ АЛГОРИТМА
*/