def restore_array(n, a):
    result = [0] * (n + 1)

    # Проверяем длину массива a
    k = (n + 1).bit_length() - 1
    if 2**k != n + 1:
        return -1

    # Восстанавливаем исходный массив
    result[1] = a[0]
    for i in range(1, n):
        if i % 2 == 1:
            result[(i + 1) // 2] = a[i]
        else:
            result[i // 2] = a[i]

    # Проверяем наличие повторяющихся элементов
    if len(set(result)) != len(result) - 1:
        return -1

    return result[1:]

n = int(input())
a = list(map(int, input().split()))

result = restore_array(n, a)

if result == -1:
    print(-1)
else:
    print(' '.join(map(str, result)))
